/*------------------------------------------------------------------------------
--       Copyright (c) 2015-2017, VeriSilicon Inc. All rights reserved        --
--         Copyright (c) 2011-2014, Google Inc. All rights reserved.          --
--                                                                            --
-- This software is confidential and proprietary and may be used only as      --
--   expressly authorized by VeriSilicon in a written licensing agreement.    --
--                                                                            --
--         This entire notice must be reproduced on all copies                --
--                       and may not be removed.                              --
--                                                                            --
--------------------------------------------------------------------------------
-- Redistribution and use in source and binary forms, with or without         --
-- modification, are permitted provided that the following conditions are met:--
--   * Redistributions of source code must retain the above copyright notice, --
--       this list of conditions and the following disclaimer.                --
--   * Redistributions in binary form must reproduce the above copyright      --
--       notice, this list of conditions and the following disclaimer in the  --
--       documentation and/or other materials provided with the distribution. --
--   * Neither the names of Google nor the names of its contributors may be   --
--       used to endorse or promote products derived from this software       --
--       without specific prior written permission.                           --
--------------------------------------------------------------------------------
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"--
-- AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  --
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE --
-- ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE  --
-- LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        --
-- CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       --
-- SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   --
-- INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    --
-- CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    --
-- ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE --
-- POSSIBILITY OF SUCH DAMAGE.                                                --
--------------------------------------------------------------------------------
------------------------------------------------------------------------------*/

HWIF_DEC_TIMEOUT,
HWIF_DEC_ERROR_INT,
HWIF_DEC_BUFFER_INT,
HWIF_DEC_BUS_INT,
HWIF_DEC_RDY_INT,
HWIF_DEC_ABORT_INT,
HWIF_DEC_IRQ,
HWIF_DEC_ABORT_E,
HWIF_DEC_IRQ_DIS,
HWIF_DEC_E,
HWIF_DEC_STRM_SWAP,
HWIF_DEC_PIC_SWAP,
HWIF_DEC_DIRMV_SWAP,
HWIF_DEC_TAB0_SWAP,
HWIF_DEC_TAB1_SWAP,
HWIF_DEC_TAB2_SWAP,
HWIF_DEC_TAB3_SWAP,
HWIF_DEC_RSCAN_SWAP,
HWIF_DEC_MODE,
HWIF_DEC_COMP_TABLE_SWAP,
HWIF_DEC_OUT_EC_BYPASS,
HWIF_DEC_OUT_RS_E,
HWIF_DEC_OUT_DIS,
HWIF_FILTERING_DIS,
HWIF_WRITE_MVS_E,
HWIF_APF_ONE_PID,
HWIF_PIC_WIDTH_IN_CBS,
HWIF_PIC_HEIGHT_IN_CBS,
HWIF_REF_FRAMES,
HWIF_STRM_START_BIT,
HWIF_SCALING_LIST_E,
HWIF_CH_QP_OFFSET,
HWIF_CH_QP_OFFSET2,
HWIF_SIGN_DATA_HIDE,
HWIF_TEMPOR_MVP_E,
HWIF_MAX_CU_QPD_DEPTH,
HWIF_CU_QPD_E,
HWIF_STREAM_LEN,
HWIF_CABAC_INIT_PRESENT,
HWIF_BLACKWHITE_E,
HWIF_WEIGHT_PRED_E,
HWIF_WEIGHT_BIPR_IDC,
HWIF_FILT_SLICE_BORDER,
HWIF_FILT_TILE_BORDER,
HWIF_ASYM_PRED_E,
HWIF_SAO_E,
HWIF_PCM_FILT_DISABLE,
HWIF_SLICE_CHQP_FLAG,
HWIF_DEPEND_SLICE_E,
HWIF_FILT_OVERRIDE_E,
HWIF_STRONG_SMOOTH_E,
HWIF_FILT_OFFSET_BETA,
HWIF_FILT_OFFSET_TC,
HWIF_SLICE_HDR_EXT_E,
HWIF_SLICE_HDR_EBITS,
HWIF_CONST_INTRA_E,
HWIF_FILT_CTRL_PRES,
HWIF_IDR_PIC_E,
HWIF_PCM_BITDEPTH_Y,
HWIF_PCM_BITDEPTH_C,
HWIF_BIT_DEPTH_Y_MINUS8,
HWIF_BIT_DEPTH_C_MINUS8,
HWIF_OUTPUT_8_BITS,
HWIF_OUTPUT_FORMAT,
HWIF_REFIDX1_ACTIVE,
HWIF_REFIDX0_ACTIVE,
HWIF_HDR_SKIP_LENGTH,
HWIF_START_CODE_E,
HWIF_INIT_QP_V0,
HWIF_INIT_QP,
HWIF_NUM_TILE_COLS_V0,
HWIF_NUM_TILE_COLS,
HWIF_NUM_TILE_ROWS_V0,
HWIF_NUM_TILE_ROWS,
HWIF_TILE_ENABLE,
HWIF_ENTR_CODE_SYNCH_E,
HWIF_TRANSFORM_MODE,
HWIF_FILT_SHARPNESS,
HWIF_FILT_TYPE,
HWIF_MCOMP_FILT_TYPE,
HWIF_HIGH_PREC_MV_E,
HWIF_COMP_PRED_MODE,
HWIF_GREF_SIGN_BIAS,
HWIF_AREF_SIGN_BIAS,
HWIF_REFER_LTERM_E,
HWIF_MIN_CB_SIZE,
HWIF_MAX_CB_SIZE,
HWIF_MIN_PCM_SIZE,
HWIF_MAX_PCM_SIZE,
HWIF_PCM_E,
HWIF_TRANSFORM_SKIP_E,
HWIF_TRANSQ_BYPASS_E,
HWIF_REFPICLIST_MOD_E,
HWIF_MIN_TRB_SIZE,
HWIF_MAX_TRB_SIZE,
HWIF_MAX_INTRA_HIERDEPTH,
HWIF_MAX_INTER_HIERDEPTH,
HWIF_PARALLEL_MERGE,
HWIF_QP_DELTA_Y_DC,
HWIF_QP_DELTA_CH_DC,
HWIF_QP_DELTA_CH_AC,
HWIF_LAST_SIGN_BIAS,
HWIF_LOSSLESS_E,
HWIF_COMP_PRED_VAR_REF1,
HWIF_COMP_PRED_VAR_REF0,
HWIF_COMP_PRED_FIXED_REF,
HWIF_SEGMENT_TEMP_UPD_E,
HWIF_SEGMENT_UPD_E,
HWIF_SEGMENT_E,
HWIF_INIT_RLIST_B2,
HWIF_INIT_RLIST_F2,
HWIF_INIT_RLIST_B1,
HWIF_INIT_RLIST_F1,
HWIF_INIT_RLIST_B0,
HWIF_INIT_RLIST_F0,
HWIF_FILT_LEVEL,
HWIF_REFPIC_SEG0,
HWIF_SKIP_SEG0,
HWIF_FILT_LEVEL_SEG0,
HWIF_QUANT_SEG0,
HWIF_INIT_RLIST_B5,
HWIF_INIT_RLIST_F5,
HWIF_INIT_RLIST_B4,
HWIF_INIT_RLIST_F4,
HWIF_INIT_RLIST_B3,
HWIF_INIT_RLIST_F3,
HWIF_REFPIC_SEG1,
HWIF_SKIP_SEG1,
HWIF_FILT_LEVEL_SEG1,
HWIF_QUANT_SEG1,
HWIF_INIT_RLIST_B8,
HWIF_INIT_RLIST_F8,
HWIF_INIT_RLIST_B7,
HWIF_INIT_RLIST_F7,
HWIF_INIT_RLIST_B6,
HWIF_INIT_RLIST_F6,
HWIF_REFPIC_SEG2,
HWIF_SKIP_SEG2,
HWIF_FILT_LEVEL_SEG2,
HWIF_QUANT_SEG2,
HWIF_INIT_RLIST_B11,
HWIF_INIT_RLIST_F11,
HWIF_INIT_RLIST_B10,
HWIF_INIT_RLIST_F10,
HWIF_INIT_RLIST_B9,
HWIF_INIT_RLIST_F9,
HWIF_REFPIC_SEG3,
HWIF_SKIP_SEG3,
HWIF_FILT_LEVEL_SEG3,
HWIF_QUANT_SEG3,
HWIF_INIT_RLIST_B14,
HWIF_INIT_RLIST_F14,
HWIF_INIT_RLIST_B13,
HWIF_INIT_RLIST_F13,
HWIF_INIT_RLIST_B12,
HWIF_INIT_RLIST_F12,
HWIF_REFPIC_SEG4,
HWIF_SKIP_SEG4,
HWIF_FILT_LEVEL_SEG4,
HWIF_QUANT_SEG4,
HWIF_INIT_RLIST_B15,
HWIF_INIT_RLIST_F15,
HWIF_REFPIC_SEG5,
HWIF_SKIP_SEG5,
HWIF_FILT_LEVEL_SEG5,
HWIF_QUANT_SEG5,
HWIF_PARTIAL_CTB_X,
HWIF_PARTIAL_CTB_Y,
HWIF_PIC_WIDTH_4X4,
HWIF_PIC_HEIGHT_4X4,
HWIF_REFPIC_SEG6,
HWIF_SKIP_SEG6,
HWIF_FILT_LEVEL_SEG6,
HWIF_QUANT_SEG6,
HWIF_REFPIC_SEG7,
HWIF_SKIP_SEG7,
HWIF_FILT_LEVEL_SEG7,
HWIF_QUANT_SEG7,
HWIF_LREF_WIDTH,
HWIF_LREF_HEIGHT,
HWIF_GREF_WIDTH,
HWIF_GREF_HEIGHT,
HWIF_AREF_WIDTH,
HWIF_AREF_HEIGHT,
HWIF_LREF_HOR_SCALE,
HWIF_LREF_VER_SCALE,
HWIF_GREF_HOR_SCALE,
HWIF_GREF_VER_SCALE,
HWIF_AREF_HOR_SCALE,
HWIF_AREF_VER_SCALE,
HWIF_TIMEOUT_OVERRIDE_E,
HWIF_TIMEOUT_CYCLES,
HWIF_CUR_POC_00,
HWIF_CUR_POC_01,
HWIF_CUR_POC_02,
HWIF_CUR_POC_03,
HWIF_FILT_REF_ADJ_0,
HWIF_FILT_REF_ADJ_1,
HWIF_FILT_REF_ADJ_2,
HWIF_FILT_REF_ADJ_3,
HWIF_CUR_POC_04,
HWIF_CUR_POC_05,
HWIF_CUR_POC_06,
HWIF_CUR_POC_07,
HWIF_FILT_MB_ADJ_0,
HWIF_FILT_MB_ADJ_1,
HWIF_FILT_MB_ADJ_2,
HWIF_FILT_MB_ADJ_3,
HWIF_CUR_POC_08,
HWIF_CUR_POC_09,
HWIF_CUR_POC_10,
HWIF_CUR_POC_11,
HWIF_CUR_POC_12,
HWIF_CUR_POC_13,
HWIF_CUR_POC_14,
HWIF_CUR_POC_15,
HWIF_APF_DISABLE,
HWIF_APF_SINGLE_PU_MODE,
HWIF_APF_THRESHOLD,
HWIF_DEC_CLK_GATE_IDLE_E,
HWIF_DEC_CLK_GATE_E,
HWIF_DEC_REFER_DOUBLEBUFFER_E,
HWIF_DEC_AXI_RD_ID_E,
HWIF_DEC_AXI_WD_ID_E,
HWIF_DEC_BUSWIDTH,
HWIF_DEC_MAX_BURST,
HWIF_DEC_AXI_WR_ID,
HWIF_DEC_AXI_RD_ID,
HWIF_PERF_CYCLE_COUNT,
HWIF_DEC_OUT_YBASE_MSB,
HWIF_DEC_OUT_YBASE_LSB,
HWIF_REFER0_YBASE_MSB,
HWIF_REFER0_YBASE_LSB,
HWIF_REFER1_YBASE_MSB,
HWIF_REFER1_YBASE_LSB,
HWIF_REFER2_YBASE_MSB,
HWIF_REFER2_YBASE_LSB,
HWIF_REFER3_YBASE_MSB,
HWIF_REFER3_YBASE_LSB,
HWIF_REFER4_YBASE_MSB,
HWIF_REFER4_YBASE_LSB,
HWIF_REFER5_YBASE_MSB,
HWIF_REFER5_YBASE_LSB,
HWIF_REFER6_YBASE_MSB,
HWIF_SEGMENT_WRITE_BASE_MSB,
HWIF_REFER6_YBASE_LSB,
HWIF_SEGMENT_WRITE_BASE_LSB,
HWIF_REFER7_YBASE_MSB,
HWIF_SEGMENT_READ_BASE_MSB,
HWIF_REFER7_YBASE_LSB,
HWIF_SEGMENT_READ_BASE_LSB,
HWIF_REFER8_YBASE_MSB,
HWIF_REFER8_YBASE_LSB,
HWIF_REFER9_YBASE_MSB,
HWIF_REFER9_YBASE_LSB,
HWIF_REFER10_YBASE_MSB,
HWIF_REFER10_YBASE_LSB,
HWIF_REFER11_YBASE_MSB,
HWIF_REFER11_YBASE_LSB,
HWIF_REFER12_YBASE_MSB,
HWIF_REFER12_YBASE_LSB,
HWIF_REFER13_YBASE_MSB,
HWIF_REFER13_YBASE_LSB,
HWIF_REFER14_YBASE_MSB,
HWIF_REFER14_YBASE_LSB,
HWIF_REFER15_YBASE_MSB,
HWIF_REFER15_YBASE_LSB,
HWIF_DEC_OUT_CBASE_MSB,
HWIF_DEC_OUT_CBASE_LSB,
HWIF_REFER0_CBASE_MSB,
HWIF_REFER0_CBASE_LSB,
HWIF_REFER1_CBASE_MSB,
HWIF_REFER1_CBASE_LSB,
HWIF_REFER2_CBASE_MSB,
HWIF_REFER2_CBASE_LSB,
HWIF_REFER3_CBASE_MSB,
HWIF_REFER3_CBASE_LSB,
HWIF_REFER4_CBASE_MSB,
HWIF_REFER4_CBASE_LSB,
HWIF_REFER5_CBASE_MSB,
HWIF_REFER5_CBASE_LSB,
HWIF_REFER6_CBASE_MSB,
HWIF_REFER6_CBASE_LSB,
HWIF_REFER7_CBASE_MSB,
HWIF_REFER7_CBASE_LSB,
HWIF_REFER8_CBASE_MSB,
HWIF_REFER8_CBASE_LSB,
HWIF_REFER9_CBASE_MSB,
HWIF_REFER9_CBASE_LSB,
HWIF_REFER10_CBASE_MSB,
HWIF_REFER10_CBASE_LSB,
HWIF_REFER11_CBASE_MSB,
HWIF_REFER11_CBASE_LSB,
HWIF_REFER12_CBASE_MSB,
HWIF_REFER12_CBASE_LSB,
HWIF_REFER13_CBASE_MSB,
HWIF_REFER13_CBASE_LSB,
HWIF_REFER14_CBASE_MSB,
HWIF_REFER14_CBASE_LSB,
HWIF_REFER15_CBASE_MSB,
HWIF_REFER15_CBASE_LSB,
HWIF_DEC_OUT_DBASE_MSB,
HWIF_DEC_OUT_DBASE_LSB,
HWIF_REFER0_DBASE_MSB,
HWIF_REFER0_DBASE_LSB,
HWIF_REFER1_DBASE_MSB,
HWIF_REFER1_DBASE_LSB,
HWIF_REFER2_DBASE_MSB,
HWIF_REFER2_DBASE_LSB,
HWIF_REFER3_DBASE_MSB,
HWIF_REFER3_DBASE_LSB,
HWIF_REFER4_DBASE_MSB,
HWIF_REFER4_DBASE_LSB,
HWIF_REFER5_DBASE_MSB,
HWIF_REFER5_DBASE_LSB,
HWIF_REFER6_DBASE_MSB,
HWIF_REFER6_DBASE_LSB,
HWIF_REFER7_DBASE_MSB,
HWIF_REFER7_DBASE_LSB,
HWIF_REFER8_DBASE_MSB,
HWIF_REFER8_DBASE_LSB,
HWIF_REFER9_DBASE_MSB,
HWIF_REFER9_DBASE_LSB,
HWIF_REFER10_DBASE_MSB,
HWIF_REFER10_DBASE_LSB,
HWIF_REFER11_DBASE_MSB,
HWIF_REFER11_DBASE_LSB,
HWIF_REFER12_DBASE_MSB,
HWIF_REFER12_DBASE_LSB,
HWIF_REFER13_DBASE_MSB,
HWIF_REFER13_DBASE_LSB,
HWIF_REFER14_DBASE_MSB,
HWIF_REFER14_DBASE_LSB,
HWIF_REFER15_DBASE_MSB,
HWIF_REFER15_DBASE_LSB,
HWIF_TILE_BASE_MSB,
HWIF_TILE_BASE_LSB,
HWIF_STREAM_BASE_MSB,
HWIF_STREAM_BASE_LSB,
HWIF_SCALE_LIST_BASE_MSB,
HWIF_CTX_COUNTER_BASE_MSB,
HWIF_SCALE_LIST_BASE_LSB,
HWIF_CTX_COUNTER_BASE_LSB,
HWIF_PROB_TAB_BASE_MSB,
HWIF_PROB_TAB_BASE_LSB,
HWIF_DEC_RSY_BASE_MSB,
HWIF_DEC_RSY_BASE_LSB,
HWIF_DEC_RSC_BASE_MSB,
HWIF_DEC_RSC_BASE_LSB,
HWIF_DEC_VERT_FILT_BASE_MSB,
HWIF_DEC_VERT_FILT_BASE_LSB,
HWIF_DEC_VERT_SAO_BASE_MSB,
HWIF_DEC_VERT_SAO_BASE_LSB,
HWIF_DEC_BSD_CTRL_BASE_MSB,
HWIF_DEC_BSD_CTRL_BASE_LSB,
HWIF_DEC_DS_E,
HWIF_DEC_DS_Y,
HWIF_DEC_DS_X,
HWIF_DEC_DSY_BASE_MSB,
HWIF_DEC_DSY_BASE_LSB,
HWIF_DEC_DSC_BASE_MSB,
HWIF_DEC_DSC_BASE_LSB,
HWIF_DEC_OUT_TYBASE_MSB,
HWIF_DEC_OUT_TYBASE_LSB,
HWIF_REFER0_TYBASE_MSB,
HWIF_REFER0_TYBASE_LSB,
HWIF_REFER1_TYBASE_MSB,
HWIF_REFER1_TYBASE_LSB,
HWIF_REFER2_TYBASE_MSB,
HWIF_REFER2_TYBASE_LSB,
HWIF_REFER3_TYBASE_MSB,
HWIF_REFER3_TYBASE_LSB,
HWIF_REFER4_TYBASE_MSB,
HWIF_REFER4_TYBASE_LSB,
HWIF_REFER5_TYBASE_MSB,
HWIF_REFER5_TYBASE_LSB,
HWIF_REFER6_TYBASE_MSB,
HWIF_REFER6_TYBASE_LSB,
HWIF_REFER7_TYBASE_MSB,
HWIF_REFER7_TYBASE_LSB,
HWIF_REFER8_TYBASE_MSB,
HWIF_REFER8_TYBASE_LSB,
HWIF_REFER9_TYBASE_MSB,
HWIF_REFER9_TYBASE_LSB,
HWIF_REFER10_TYBASE_MSB,
HWIF_REFER10_TYBASE_LSB,
HWIF_REFER11_TYBASE_MSB,
HWIF_REFER11_TYBASE_LSB,
HWIF_REFER12_TYBASE_MSB,
HWIF_REFER12_TYBASE_LSB,
HWIF_REFER13_TYBASE_MSB,
HWIF_REFER13_TYBASE_LSB,
HWIF_REFER14_TYBASE_MSB,
HWIF_REFER14_TYBASE_LSB,
HWIF_REFER15_TYBASE_MSB,
HWIF_REFER15_TYBASE_LSB,
HWIF_DEC_OUT_TCBASE_MSB,
HWIF_DEC_OUT_TCBASE_LSB,
HWIF_REFER0_TCBASE_MSB,
HWIF_REFER0_TCBASE_LSB,
HWIF_REFER1_TCBASE_MSB,
HWIF_REFER1_TCBASE_LSB,
HWIF_REFER2_TCBASE_MSB,
HWIF_REFER2_TCBASE_LSB,
HWIF_REFER3_TCBASE_MSB,
HWIF_REFER3_TCBASE_LSB,
HWIF_REFER4_TCBASE_MSB,
HWIF_REFER4_TCBASE_LSB,
HWIF_REFER5_TCBASE_MSB,
HWIF_REFER5_TCBASE_LSB,
HWIF_REFER6_TCBASE_MSB,
HWIF_REFER6_TCBASE_LSB,
HWIF_REFER7_TCBASE_MSB,
HWIF_REFER7_TCBASE_LSB,
HWIF_REFER8_TCBASE_MSB,
HWIF_REFER8_TCBASE_LSB,
HWIF_REFER9_TCBASE_MSB,
HWIF_REFER9_TCBASE_LSB,
HWIF_REFER10_TCBASE_MSB,
HWIF_REFER10_TCBASE_LSB,
HWIF_REFER11_TCBASE_MSB,
HWIF_REFER11_TCBASE_LSB,
HWIF_REFER12_TCBASE_MSB,
HWIF_REFER12_TCBASE_LSB,
HWIF_REFER13_TCBASE_MSB,
HWIF_REFER13_TCBASE_LSB,
HWIF_REFER14_TCBASE_MSB,
HWIF_REFER14_TCBASE_LSB,
HWIF_REFER15_TCBASE_MSB,
HWIF_REFER15_TCBASE_LSB,
HWIF_STRM_BUF_LEN,
HWIF_STRM_START_OFFSET,
